<#ibiztemplate>
TARGET=PSDESERVICEAPI
</#ibiztemplate>
package ${pub.getPKGCodeName()}.service.${item.getPSSysServiceAPI().getCodeName()?lower_case}.dto;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.math.BigInteger;
import java.util.Map;
import java.util.HashMap;
import java.io.Serializable;
import java.math.BigDecimal;
<#--添加值规则相关引入-->
<@addValueRuleImport />
import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().getCodeName()?lower_case}.domain.${de.getCodeName()};
import org.springframework.cglib.beans.BeanCopier;

import com.fasterxml.jackson.annotation.JsonAutoDetect;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * 服务DTO对象[${item.getCodeName()}DTO]
 */
public class ${item.getCodeName()}DTO implements Serializable {

	private static final long serialVersionUID = 1L;

<#--  服务实体属性相关  -->
<#if item.getPSDEServiceAPIFields()??>
    <#list item.getPSDEServiceAPIFields() as apifield>
    /**
     * 属性 [${apifield.getName()}]
     *
     */
    <#--生成值规则注解-->
    <@addValueRuleAnno apifield.getPSDEField() />
    <#assign defDataType = (apifield.getPSDEField().getDataType())!"">
    <#if defDataType == "DATETIME" || (defDataType=='PICKUPDATA' && srfdatatype(apifield.getStdDataType())== "DATETIME" && apifield.getPSDEField().getValueFormat()=="%1$tY-%1$tm-%1$td %1$tH:%1$tM:%1$tS")>
    @JsonFormat(pattern="yyyy-MM-dd HH:mm:ss", locale = "zh" , timezone="GMT+8")
    <#elseif defDataType == "DATE" || (defDataType=='PICKUPDATA' && srfdatatype(apifield.getStdDataType())== "DATETIME" && apifield.getPSDEField().getValueFormat()=="%1$tY-%1$tm-%1$td")>
    @JsonFormat(pattern="yyyy-MM-dd", locale = "zh" , timezone="GMT+8")
    <#elseif defDataType == "TIME" || (defDataType=='PICKUPDATA' && srfdatatype(apifield.getStdDataType())== "DATETIME" && apifield.getPSDEField().getValueFormat()=="%1$tH:%1$tM:%1$tS")>
    @JsonFormat(pattern="HH:mm", locale = "zh" , timezone="GMT+8")
    </#if>
    private ${srfjavatype(apifield.getStdDataType())} ${apifield.getCodeName()?uncap_first};

    @JsonIgnore
    private boolean ${apifield.getCodeName()?uncap_first}DirtyFlag;

    </#list>

    <#list item.getPSDEServiceAPIFields() as apifield>
    /**
     * 获取 [${apifield.getName()}]
     */
    @JsonProperty("${apifield.getCodeName()?lower_case}")
    public ${srfjavatype(apifield.getStdDataType())} get${apifield.getCodeName()?cap_first}(){
        return ${apifield.getCodeName()?uncap_first} ;
    }

    /**
     * 设置 [${apifield.getName()}]
     */
    @JsonProperty("${apifield.getCodeName()?lower_case}")
    public void set${apifield.getCodeName()?cap_first}(${srfjavatype(apifield.getStdDataType())}  ${apifield.getCodeName()?uncap_first}){
        this.${apifield.getCodeName()?uncap_first} = ${apifield.getCodeName()?uncap_first} ;
        this.${apifield.getCodeName()?uncap_first}DirtyFlag = true ;
    }

    /**
     * 获取 [${apifield.getName()}]脏标记
     */
    @JsonIgnore
    public boolean get${apifield.getCodeName()?cap_first}DirtyFlag(){
        return ${apifield.getCodeName()?uncap_first}DirtyFlag ;
    }

    </#list>
</#if>

<#comment>true/false暂时为是否导出子数据</#comment>
<#if item.getPSDEServiceAPIRSs()?? >
    <#list item.getPSDEServiceAPIRSs() as apider>
    <#if apider.getMinorPSDEServiceAPI().isNested()>
    <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
    
    <#--  
    <#if apider.getParentFilter()?? >
        <#assign subDTOs = apider.getParentFilter()?uncap_first >
    <#else>
        <#if apider.getPSDER1N()??>
        <#assign subDTOs = apider.getPSDER1N().getCodeName()?uncap_first >
        </#if>
    </#if>  
    -->
    /**
     *  [${apider.getMinorPSDEServiceAPI().getName()}]
     */
	private List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${subDTOs} = new ArrayList<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO>();

    @JsonProperty("${srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case}")
    public List<${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> get${subDTOs?cap_first}(){
        return ${subDTOs} ;
    }

    @JsonProperty("${srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case}")
    public void set${subDTOs?cap_first}(List <${apider.getMinorPSDEServiceAPI().getCodeName()}DTO> ${subDTOs}){
        this.${subDTOs} = ${subDTOs} ;
    }

    </#if>
    </#list>
</#if>

    public ${de.getCodeName()} toDO() {
        ${de.getCodeName()} srfdomain = new ${de.getCodeName()}();
<#list item.getPSDEServiceAPIFields() as apifield>
    <#if apifield.getPSDEField()??>
    <#assign defield=apifield.getPSDEField()>
        if(get${apifield.getCodeName()?cap_first}DirtyFlag())
            srfdomain.set${defield.getCodeName()?cap_first}(${apifield.getCodeName()?uncap_first});
    </#if>
</#list>

<#if item.getPSDEServiceAPIRSs()?? >
    <#list item.getPSDEServiceAPIRSs() as apider>
    <#if apider.getMinorPSDEServiceAPI().isNested()>
      <#if apider.getPSDER1N()?? && apider.getPSDER1N().isNestedRS()>
      <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
      <#assign der = apider.getPSDER1N() >
        for(${apider.getMinorPSDEServiceAPI().getCodeName()}DTO dto : this.get${subDTOs?cap_first}()){
            srfdomain.get${der.getMinorCodeName()?cap_first}().add(dto.toDO());    
        }

      </#if>
    </#if>
  </#list>
</#if>
        return srfdomain;
    }

    public void fromDO(${de.getCodeName()} srfdomain) {
        if(srfdomain == null )
          return ;
<#list item.getPSDEServiceAPIFields() as apifield>
    <#if apifield.getPSDEField()??>
    <#assign defield=apifield.getPSDEField()>
        if(srfdomain.get${defield.getCodeName()?cap_first}DirtyFlag())
            this.set${apifield.getCodeName()?cap_first}(srfdomain.get${defield.getCodeName()?cap_first}());
    </#if>
</#list>

<#if item.getPSDEServiceAPIRSs()?? >
    <#list item.getPSDEServiceAPIRSs() as apider>
    <#if apider.getMinorPSDEServiceAPI().isNested()>
      <#if apider.getPSDER1N()?? && apider.getPSDER1N().isNestedRS()>
      <#assign subDTOs = srfpluralize(apider.getMinorPSDEServiceAPI().getCodeName())?lower_case >
      <#assign der = apider.getPSDER1N() >
        ${subDTOs}.clear();
        for(${pub.getPKGCodeName()}.core.${der.getMinorPSDataEntity().getPSSystemModule().getCodeName()?lower_case}.domain.${der.getMinorPSDataEntity().getCodeName()} ${der.getMinorPSDataEntity().getCodeName()?uncap_first} : srfdomain.get${der.getMinorCodeName()?cap_first}()){
            ${apider.getMinorPSDEServiceAPI().getCodeName()}DTO dto = new ${apider.getMinorPSDEServiceAPI().getCodeName()}DTO() ;
            dto.fromDO(${der.getMinorPSDataEntity().getCodeName()?uncap_first});
            ${subDTOs}.add(dto);
        }

      </#if>
    </#if>
  </#list>
</#if>
    }

    <#--public List<${de.getCodeName()}DTO> fromPOPage(Page<${de.getCodeName()}> poPage)   {-->
    public List<${de.getCodeName()}DTO> fromDOPage(List<${de.getCodeName()}> poPage)   {
        if(poPage == null)
            return null;
        List<${de.getCodeName()}DTO> dtos=new ArrayList<${de.getCodeName()}DTO>();
        <#--for(${de.getCodeName()} po : poPage.getRecords()) {-->
        for(${de.getCodeName()} domain : poPage) {
            ${de.getCodeName()}DTO dto = new ${de.getCodeName()}DTO();
            dto.fromDO(domain);
            dtos.add(dto);
        }
        return dtos;
    }
}

<#macro addValueRuleAnno defield>
    <#comment>在属性字段中添加值规则注解</#comment>
    <#--<#if ((pub.getUserTag4())!'')=='nancy'>-->
        <#if defield.getAllPSDEFValueRules()??>
            <#list defield.getAllPSDEFValueRules() as valueRule>
    @${de.codeName}${valueRule.getPSDEField().codeName?cap_first}${valueRule.codeName}(info = "${valueRule.getName()}")
            </#list>
        </#if>
    <#--</#if>-->
</#macro>

<#macro addValueRuleImport >
    <#comment>添加值规则引用</#comment>
    <#--<#if ((pub.getUserTag4())!'')=='nancy'>-->
import ${pub.getPKGCodeName()}.core.${de.getPSSystemModule().codeName?lower_case}.valuerule.anno.${de.codeName?lower_case}.*;
    <#--</#if>-->
</#macro>
