<#ibiztemplate>
TARGET=PSSYSSERVICEAPI
</#ibiztemplate>
<#if item.getAPIMode()?? && item.getAPIMode() == 2>
    <#assign pubPkgCodeName = pub.getPKGCodeName()>
    <#assign sysApiCN = item.getCodeName()>
    <#assign sysApiCNLC = sysApiCN?lower_case>
package ${pubPkgCodeName}.service.${sysApiCNLC}.resource;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.http.HttpStatus;
import org.springframework.util.StringUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
import com.alibaba.fastjson.JSONObject;

@Api(tags = {"${sysApiCNLC}" })
@RestController
@RequestMapping(value = "")
public class ${sysApiCN}Resource {
    <#--  工作流引擎回调  -->
    <#if item.getPredefinedType()?? && item.getPredefinedType() == "WFCALLBACK">
    /**
     * 开始流程回调【WFStart】
     */
    @RequestMapping(method = RequestMethod.POST, value = "/${sysApiCNLC}/wfstart")
    public ResponseEntity<JSONObject> wfStart(@RequestBody JSONObject jo) {
        JSONObject rst = new JSONObject();
        rst.put("rst", "0");
        rst.put("errmsg", "方法未实现");
        return ResponseEntity.status(HttpStatus.OK).body(rst);
    }

    /**
     * 流程处理回调【WFSubmit】
     */
    @RequestMapping(method = RequestMethod.POST, value = "/${sysApiCNLC}/wfsubmit")
    public ResponseEntity<JSONObject> wfSubmit(@RequestBody JSONObject jo) {
        JSONObject rst = new JSONObject();
        rst.put("rst", "0");
        rst.put("errmsg", "方法未实现");
        return ResponseEntity.status(HttpStatus.OK).body(rst);
    }

    /**
     * 流程结束回调【WFClose】
     */
    @RequestMapping(method = RequestMethod.POST, value = "/${sysApiCNLC}/wfclose")
    public ResponseEntity<JSONObject> wfClose(@RequestBody JSONObject jo) {
        JSONObject rst = new JSONObject();
        rst.put("rst", "0");
        rst.put("errmsg", "方法未实现");
        return ResponseEntity.status(HttpStatus.OK).body(rst);
    }

    /**
     * 流程跳转回调【WFGoto】
     */
    @RequestMapping(method = RequestMethod.POST, value = "/${sysApiCNLC}/wfgoto")
    public ResponseEntity<JSONObject> wfGoto(@RequestBody JSONObject jo) {
        JSONObject rst = new JSONObject();
        rst.put("rst", "0");
        rst.put("errmsg", "方法未实现");
        return ResponseEntity.status(HttpStatus.OK).body(rst);
    }

    /**
     * 流程重启回调【WFRestart】
     */
    @RequestMapping(method = RequestMethod.POST, value = "/${sysApiCNLC}/wfrestart")
    public ResponseEntity<JSONObject> wfRestart(@RequestBody JSONObject jo) {
        JSONObject rst = new JSONObject();
        rst.put("rst", "0");
        rst.put("errmsg", "方法未实现");
        return ResponseEntity.status(HttpStatus.OK).body(rst);
    }

    /**
     * 流程撤回回调【WFRollback】
     */
    @RequestMapping(method = RequestMethod.POST, value = "/${sysApiCNLC}/wfrollback")
    public ResponseEntity<JSONObject> wfRollback(@RequestBody JSONObject jo) {
        JSONObject rst = new JSONObject();
        rst.put("rst", "0");
        rst.put("errmsg", "方法未实现");
        return ResponseEntity.status(HttpStatus.OK).body(rst);
    }

    /**
     * 流程退回回调【WFSendBack】
     */
    @RequestMapping(method = RequestMethod.POST, value = "/${sysApiCNLC}/wfsendback")
    public ResponseEntity<JSONObject> wfSendBack(@RequestBody JSONObject jo) {
        JSONObject rst = new JSONObject();
        rst.put("rst", "0");
        rst.put("errmsg", "方法未实现");
        return ResponseEntity.status(HttpStatus.OK).body(rst);
    }

    /**
     * 流程重新分配回调【WFReassign】
     */
    @RequestMapping(method = RequestMethod.POST, value = "/${sysApiCNLC}/wfreassign")
    public ResponseEntity<JSONObject> wfReassign(@RequestBody JSONObject jo) {
        JSONObject rst = new JSONObject();
        rst.put("rst", "0");
        rst.put("errmsg", "方法未实现");
        return ResponseEntity.status(HttpStatus.OK).body(rst);
    }

    /**
     * 流程标记已读回调【WFMarkRead】
     */
    @RequestMapping(method = RequestMethod.POST, value = "/${sysApiCNLC}/wfmarkread")
    public ResponseEntity<JSONObject> wfMarkRead(@RequestBody JSONObject jo) {
        JSONObject rst = new JSONObject();
        rst.put("rst", "0");
        rst.put("errmsg", "方法未实现");
        return ResponseEntity.status(HttpStatus.OK).body(rst);
    }

    /**
     * 流程挂起回调【WFSuspend】
     */
    @RequestMapping(method = RequestMethod.POST, value = "/${sysApiCNLC}/wfsuspend")
    public ResponseEntity<JSONObject> wfSuspend(@RequestBody JSONObject jo) {
        JSONObject rst = new JSONObject();
        rst.put("rst", "0");
        rst.put("errmsg", "方法未实现");
        return ResponseEntity.status(HttpStatus.OK).body(rst);
    }

    /**
     * 流程恢复回调【WFResume】
     */
    @RequestMapping(method = RequestMethod.POST, value = "/${sysApiCNLC}/wfresume")
    public ResponseEntity<JSONObject> wfResume(@RequestBody JSONObject jo) {
        JSONObject rst = new JSONObject();
        rst.put("rst", "0");
        rst.put("errmsg", "方法未实现");
        return ResponseEntity.status(HttpStatus.OK).body(rst);
    }
    </#if>
}
</#if>
